
#include "terasic_includes.h"
#include "vip_fr.h"
#include "./graphic_lib/simple_graphics.h"
#include "./graphic_lib/gimp_bmp.h"
#include "./graphic_lib/draw_gimps.h"

#define FRAME_WIDTH  480
#define FRAME_HEIGHT 272


#define FR_FRAME_0  (SDRAM_BASE)
#define FR_FRAME_1  (SDRAM_BASE + FRAME_WIDTH*FRAME_HEIGHT*4)

// Defina o no el Dual Frame Buffer para manejar 2 frames de video.
//#define DUAL_FRAME_BUFFER


// Imagenes, leidas desde la EPCS
extern struct gimp_image_struct logoADT;



void draw_init(VIP_FRAME_READER *pReader)
{
 VIPFR_ActiveDrawFrame(pReader);

 DispIMAGE((void*)pReader, 0, 0,&logoADT);
 
 // Se dibuja una caja sin relleno en la posicin X=400, Y=500, con dimensiones W=100 y H=200
 vid_draw_box (1, 1, 400, 200, WHITE_24, DO_NOT_FILL, pReader);
 
 
 vid_draw_circle(200, 100, 50, GREEN_24, DO_FILL, pReader);
 vid_draw_round_corner_box ( 100, 150, 150, 50, 
                                7, 0x0fF378, DO_FILL, pReader);
 vid_draw_line(0, 272, 100, 200, 2, 0xffffff, pReader);
 vid_print_string(100, 0, GHOSTWHITE_24, cour10_font, pReader, "Semillero ADT");
 vid_print_string_alpha(0, 0,DARKBLUE_24, CLEAR_BACKGROUND, tahomabold_32, pReader, "Holguer A. Becerra");


}
void generate_fractal(alt_video_display * display);


int main()
{
    VIP_FRAME_READER *pReader;
    
    ////////Se inicializa el HW del sistema//////////////
    // frame reader
#ifdef DUAL_FRAME_BUFFER    
    pReader =  VIPFR_Init(ALT_VIP_VFR_0_BASE, (void *)FR_FRAME_0, (void *)FR_FRAME_1, FRAME_WIDTH, FRAME_HEIGHT);
#else    
    pReader =  VIPFR_Init(ALT_VIP_VFR_0_BASE, (void *)FR_FRAME_0, (void *)FR_FRAME_0, FRAME_WIDTH, FRAME_HEIGHT);
#endif // DUAL_FRAME_BUFFER    
    VIPFR_Go(pReader, TRUE);
    
   // se activa el frame de video
    VIPFR_ActiveDrawFrame(pReader);
    
    
    
    // clean screen
    vid_clean_screen(pReader, BLACK_24);
    
    
    
    printf("Video Inicializado\n");

    
    //se dibuja los objetos que se quieren mostrar al incio
    draw_init(pReader);
    
    printf("Se dibujaron los objetos en la pantalla\n");

    while(1)
    {
       VIPFR_ActiveDrawFrame(pReader);
       usleep(10);      
    }
    
    
}
